
// Copyright (C) 1998 Cygnus Solutions
//
// This file is part of the libstdc++ version 3 distribution.
//
// This software is a copyrighted work licensed under the terms of the
// Cygnus libstdc++ license. Please consult the file LICENSE.STD for
// details.

#ifndef _CPP_BIN_CPPCONFIG
#define _CPP_BIN_CPPCONFIG 1

// XXX this flag is obsolete. there should be no mentions of it in the code.
# define _G_USE_NAMESPACE 1

// this flag might someday be useful. 
# define _G_USE_EXCEPTIONS 1 

// XXX does this belong here?  probably not.
#define __STL_USE_STD_ALLOCATORS

// this is necessary until Egcs supports separate template compilation.
#define _G_NO_TEMPLATE_EXPORT 1

#define _G_NO_STREAMBUF_ITERATORS 1  /* SGI <iterator> lacks them */
#define _G_BROKEN_CCTYPE 1           /* need #undef isspace etc. */

// CYGNUS LOCAL 9/3/1998
// This is required for limits.h to define LONG_LONG_MIN and LONG_LONG_MAX,
// which are used in std_limits.h if __STL_LONG_LONG is defined.
#if defined __linux__
// We assume glibc here.
#  ifndef __USE_GNU
#    define __USE_GNU 1
#  endif
#endif

// XXX this stuff doesn't belong here.
#ifndef __linux__
#define _ISbit(bit)     (1 << bit)
enum
{
  _ISupper = _ISbit (0),        // UPPERCASE
  _ISlower = _ISbit (1),        // lowercase
  _ISalpha = _ISbit (2),        // Alphabetic
  _ISdigit = _ISbit (3),        // Numeric
  _ISxdigit = _ISbit (4),       // Hexadecimal numeric
  _ISspace = _ISbit (5),        // Whitespace
  _ISprint = _ISbit (6),        // Printing
  _ISgraph = _ISbit (7),        // Graphical
  _ISblank = _ISbit (8),        // Blank (usually SPC and TAB)
  _IScntrl = _ISbit (9),        // Control character
  _ISpunct = _ISbit (10),       // Punctuation
  _ISalnum = _ISbit (11)        // Alphanumeric
};
#undef _ISbit
#endif

#ifdef __sun__
/* When we auto-generate this file this definition will done automatically
   as well.  */
typedef struct {
  int __fill[6];
} mbstate_t;

#endif

#endif /* _CPP_BIN_CPPCONFIG_ */

// Local Variables:
// mode:c++
// End:
